Set Score Off
Set Date Brit
Set Wrap On
Set Confirm On

Parameter Parametro

If Pcount() == 0
	Parametro := ""
	? "Uso: FiscNET <Comando FiscNET>"
	? "  onde:"
	? "     <Comando FiscNET> representa o texto das secoes 2 e 3 do protocolo FiscNET"
	?
	? "Exemplos:"
	? "  FiscNET "+Chr(34)+"EmiteLeituraX;"+Chr(34)
	? "  FiscNET "+Chr(34)+"LeHora;NomeHora=\"+Chr(34)+"Hora\"+Chr(34)+Chr(34)
	
	Return
Endif

*--- Define os codigos de erros retornados pela Logger
declare ZPM_ERRO[222]
ZPM_ERRO[1] = "Comando Invalido para o Device. Erro Interno!"
ZPM_ERRO[2] = "Impressora esta fora de linha, desligada ou desconectada"
ZPM_ERRO[3] = "Device Driver ocupado. Erro Interno!"
ZPM_ERRO[4] = "Comando nao implementado. Erro Interno!"
ZPM_ERRO[5] = "Erro de Sintaxe em comando. Erro Interno!"
ZPM_ERRO[6] = "Tempo para execucao do comando esgotado. Timeout"
ZPM_ERRO[7] = "Parametro invalido passado para a LIB"
ZPM_ERRO[8] = "LIB ja esta ativa"
ZPM_ERRO[9] = "LIB nao esta ativa"
ZPM_ERRO[10] = "Device Driver nao instalado"
ZPM_ERRO[11] = "Banco nao esta cadastrado no arquivo de configuracao"
ZPM_ERRO[12] = "Coordenadas de Valor nao informadas ou invalida"
ZPM_ERRO[13] = "Coordenadas de Extenso nao informadas ou invalida"
ZPM_ERRO[14] = "Coordenadas de Favorecido nao informadas ou invalida"
ZPM_ERRO[15] = "Coordenadas de Cidade nao informadas ou invalida"
ZPM_ERRO[16] = "Coordenadas da Data nao informadas ou invalida"
ZPM_ERRO[17] = "Erro de sintaxe em descricao das coordenadas no arquivo"
ZPM_ERRO[18] = "Coordenadas da Mensagem do cheque invalida"
ZPM_ERRO[19] = "Valor do espacamento invalido"
ZPM_ERRO[20] = "Nao conseguiu acessar arquivo de configuracao"


For i = 21 To 32
	ZPM_ERRO[i] = "Resposta nao documentada "+Str(i,2)
Next

ZPM_ERRO[33] = "Retorno Ok!"
ZPM_ERRO[34] = "Cancelamento invalido"
ZPM_ERRO[35] = "Abertura do dia invalida"
ZPM_ERRO[36] = "Aliquota nao carregada"
ZPM_ERRO[37] = "Erro na gravacao da memoria fiscal"
ZPM_ERRO[38] = "Numero Maximo de Troca de Estabelecimento alcancado"
ZPM_ERRO[39] = "Impressora em intervencao tecnica"
ZPM_ERRO[40] = "Memoria Fiscal desconectada"
ZPM_ERRO[41] = "Indice da Aliquota invalido"
ZPM_ERRO[42] = "Retorno desconhecido 42"
ZPM_ERRO[43] = "Desconto invalido"
ZPM_ERRO[44] = "Valor da aliquota invalido"
ZPM_ERRO[45] = "Perda da memoria RAM"
ZPM_ERRO[46] = "Comando aceito apenas em intervencao tecnica"
ZPM_ERRO[47] = "Retorno desconhecido 47"
ZPM_ERRO[48] = "Fechamento nao realizado"
ZPM_ERRO[49] = "Fechamento ja realizado"
ZPM_ERRO[50] = "Comando fora de sequencia"
ZPM_ERRO[51] = "Comando inexistente"
ZPM_ERRO[52] = "Impressora retornou timeout RX"
ZPM_ERRO[53] = "Retorno desconhecido 53"
ZPM_ERRO[54] = "Valor de desconto invalido"
ZPM_ERRO[55] = "Aliquota indisponivel"
ZPM_ERRO[56] = "Troca de proprietario apenas apos fechamento"
ZPM_ERRO[57] = "Memoria Fiscal cheia"
ZPM_ERRO[58] = "Troca de aliquota apenas apos fechamento"
ZPM_ERRO[59] = "Codigo de mercadoria invalida"
ZPM_ERRO[60] = "Cabecalho ja impresso"
ZPM_ERRO[61] = "Acerto de horario de verao somente apos fechamento"
ZPM_ERRO[62] = "Data nao pode ser menor que a data da ultima reducao gravada na MF"
ZPM_ERRO[63] = "Falta papel para autenticacao"
ZPM_ERRO[64] = "Nao documentado 64"
ZPM_ERRO[65] = "Desconto ou Acrescimo no subtotal invalido"
ZPM_ERRO[66] = "Indice invalido"
ZPM_ERRO[67] = "Forma de pagamento indisponivel"
ZPM_ERRO[68] = "Troca de forma de pagamento apenas apos fechamento"
ZPM_ERRO[69] = "Limite de autenticacao alcancado"
ZPM_ERRO[70] = "Finalizadora nao habilitada"
ZPM_ERRO[71] = "Papel perto do fim"
ZPM_ERRO[72] = "Campo do cheque invalido"
ZPM_ERRO[73] = "Insc Estadual ou CNPJ invalido"
ZPM_ERRO[74] = "Montante da operacao igual a zero"
ZPM_ERRO[75] = "Falta Memoria RAM"
ZPM_ERRO[76] = "Sem cartucho instalado"
ZPM_ERRO[77] = "Sem resposta"
ZPM_ERRO[78] = "Dados do cliche somente devem ser carregados apos CNPJ"
ZPM_ERRO[79] = "CPF/CNPJ invalido"
ZPM_ERRO[80] = "Cartucho inexistente ou invalido"
ZPM_ERRO[81] = "Cartucho apenas para leitura"
ZPM_ERRO[82] = "Mecanismo nao selecionado"
ZPM_ERRO[83] = "Sequencia pagamento invalida"
ZPM_ERRO[84] = "Pagamento incompleto"
ZPM_ERRO[85] = "Troca de dados cadastrais apenas apos fechamento"
ZPM_ERRO[86] = "Troca CNPJ apenas apos fechamento"
ZPM_ERRO[87] = "Cupom Totalizado em Zero"
ZPM_ERRO[88] = "Retorno desconhecido 88"
ZPM_ERRO[89] = "Nao vinculado indisponivel"
ZPM_ERRO[90] = "Troca de doc nao vinculado apenas apos o fechamento"
ZPM_ERRO[91] = "Erro na gravacao da E2PROM"
ZPM_ERRO[92] = "Nao vinculado invalido: somente entrada ou somente saida"
ZPM_ERRO[93] = "Retorno desconhecido 93"
ZPM_ERRO[94] = "Retorno desconhecido 94"
ZPM_ERRO[95] = "Retorno desconhecido 95"
ZPM_ERRO[96] = "Retorno desconhecido 96"
ZPM_ERRO[97] = "Retorno desconhecido 97"
ZPM_ERRO[98] = "Retorno desconhecido 98"
ZPM_ERRO[99] = "Retorno desconhecido 99"
ZPM_ERRO[100]= "Retorno desconhecido 100"
ZPM_ERRO[101]= "Retorno desconhecido 101"
ZPM_ERRO[102]= "Retorno desconhecido 102"
ZPM_ERRO[103]= "Retorno desconhecido 103"
ZPM_ERRO[104]= "Retorno desconhecido 104"
ZPM_ERRO[105]= "Valor do relogio invalido"
ZPM_ERRO[106]= "Acerto horario de verao apenas uma vez ao dia"
ZPM_ERRO[107]= "Data invalida"
ZPM_ERRO[108]= "Cartucho logger cheio"
ZPM_ERRO[109]= "Impressora nao esta pronta p/ imprimir (tampa aberta)"
ZPM_ERRO[110]= "Descricao invalida"
ZPM_ERRO[111]= "Sem papel"
ZPM_ERRO[112]= "Quantidade invalida"
ZPM_ERRO[113]= "Valor do item invalido"
ZPM_ERRO[114]= "Problema relogio"
ZPM_ERRO[115]= "Cheque nao posicionado"
ZPM_ERRO[116]= "Caracter invalido"
ZPM_ERRO[117]= "Numero de operacoes excedidas"
ZPM_ERRO[118]= "Retorno desconhecido 118"
ZPM_ERRO[119]= "Necessita troca de usuario"
ZPM_ERRO[120]= "COO invalido"
ZPM_ERRO[121]= "Horario de verao ja acertado"
ZPM_ERRO[122]= "Nova via do cupom vinculado nao coincidente - Erro impressao cheque"
ZPM_ERRO[123]= "Limite de emissao de fita detalhe por IT alcancado"
ZPM_ERRO[124]= "Versao de software invalida"


#define LASTERR         124

ZPM_ERRO[LASTERR+1] = "Erro desconhecido "
ZPM_ERRO[LASTERR+2] = "Impressora retornou caracter desconhecido "

for i = LASTERR+3 to 199
	ZPM_ERRO[i] = "Erro desconhecido "+str(i)
next

ZPM_ERRO[200] = "Em periodo de venda"
ZPM_ERRO[201] = "Em venda de item"
ZPM_ERRO[202] = "Em Intervencao Tecnica"
ZPM_ERRO[203] = "Em Pagamento de Cupom"
ZPM_ERRO[204] = "Em Propaganda"
ZPM_ERRO[205] = "Dia Fechado"
ZPM_ERRO[206] = "Em acrescimo/desconto subtotal"
ZPM_ERRO[207] = "Fechamento nao realizado"
ZPM_ERRO[208] = "Estado Perda da memoria RAM"
ZPM_ERRO[209] = "Estado Papel perto do fim"
ZPM_ERRO[210] = "Estado Memoria Fiscal desconectada"
ZPM_ERRO[211] = "Estado sem cartucho"
ZPM_ERRO[212] = "Cartucho apenas para leitura"
ZPM_ERRO[213] = "Mecanismo nao configurado"
ZPM_ERRO[214] = "Cartucho virgem"
ZPM_ERRO[215] = "Estado: Fim de Papel"
ZPM_ERRO[216] = "Em nao vinculado entrada"
ZPM_ERRO[217] = "Em nao vinculado saida"
ZPM_ERRO[218] = "Em relatorio gerencial"
ZPM_ERRO[219] = "Estado relogio inconsistente"
ZPM_ERRO[220] = "Estado Overflow COO"
ZPM_ERRO[221] = "Em Cupom Vinculado"
ZPM_ERRO[222] = "Em Versao software invalida"

#define	LASTEST		222

*-------------------------------------------------------

Public RESP_OK

RESP_OK = asc("!")

Clear


*--- Inicializa biblioteca
*? "Versao da LIB ["+LIBVer()+"]"
Retorno = InitComm()
If Retorno <> 33
	? "Erro ao acessar a biblioteca: ["+ZPM_ERRO[Retorno]+"]"
	Quit
Endif

If LoopTest() == 1
	Clear
	? "Cabo serial possui 'loop' CTS<->RTS. Verifique especificacao correta no manual."
	EndComm()
	Quit
Endif

pRet = Space(4100)
ret = CmdFiscNET (Parametro, @pRet)
? "CmdFiscNET ("+Parametro+"): "+str(ret)
If ret == 0 .or. ret == 6
	? "Retorno:"
	? pRet
	
	* Grava em arquivo
	Fp := Fcreate("FISCNET.TXT")
	If Fp >= 0
		Fwrite(Fp, pRet, Len(pRet))
		Fclose(Fp)
		?
		? "Arquivo FISCNET.TXT gerado!"
	EndIf
EndIf

Set Color To
EndComm()
Quit
