//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include "Fiscmain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmFiscNET *frmFiscNET;
//---------------------------------------------------------------------------
__fastcall TfrmFiscNET::TfrmFiscNET(TComponent* Owner)
    : TForm(Owner)
{
 dll_handle = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TfrmFiscNET::btEnviarClick(TObject *Sender)
{
 char arquivo[50] = "FiscNET.txt";

 // Instancia a dll, caso necessrio
 if (!IniciaSerial())
    return;

 lbStatus->Caption = "Enviando...";
 lbStatus->Refresh();
 lbResposta->Clear();
 lbResposta->Refresh();

 // Seta o timeout
 (*((int WINAPI (*) (char *)) GetProcAddress (dll_handle, "ecf_ProximoTimeout"))) (ebTimeout->Text.c_str());

 // Executa o comando
 int ret = (*((int WINAPI (*) (char *, char *)) GetProcAddress (dll_handle, "ecf_FiscNET"))) (ebComando->Text.c_str(), arquivo);
 if (ret != 33)         // 33 = Comando OK
    {
    char msg[80];
    sprintf (msg, "Erro '%d' ao executar o comando!", ret);
    MessageBox (NULL, msg, "Erro", MB_ICONSTOP);
    return;
    }

 // Comando OK: abre o arquivo e coloca os dados recebidos na listbox
 lbResposta->Items->LoadFromFile (AnsiString (arquivo));
 lbStatus->Caption = "";
}

//---------------------------------------------------------------------------

void __fastcall TfrmFiscNET::btSairClick(TObject *Sender)
{
 // Encerra a serial e libera a dll
 EncerraSerial(true);

 // Encerra o aplicativo
 Close();
}
//---------------------------------------------------------------------------
bool __fastcall TfrmFiscNET::IniciaSerial(void)
{
 if (!dll_handle)
    {
    if ( !(dll_handle = LoadLibrary("DllLog32.dll")) )
        {
        MessageBox (NULL, "No foi possvel carregar a 'DllLog32.dll'!", "Erro", MB_ICONSTOP);
        return false;
        }
    }

 // Encerra a serial sem liberar a dll
 EncerraSerial(false);

 // Configura a serial
 int ret = (*((int WINAPI (*) (char *)) GetProcAddress (dll_handle, "ecf_InicializaDLL"))) (cbSerial->Text.c_str());

 if (ret != 33)
    {
    EncerraSerial (true);
    MessageBox (NULL, "No foi possvel acessar a porta serial!", "Erro", MB_ICONSTOP);
    return false;
    }

 return true;
}
//---------------------------------------------------------------------------
void __fastcall TfrmFiscNET::EncerraSerial(bool Libera)
{
 if (dll_handle)
    {
    (*((int WINAPI (*) (void)) GetProcAddress (dll_handle, "ecf_FinalizaDLL"))) ();
    if (Libera)
        {
        FreeLibrary (dll_handle);
        dll_handle = NULL;
        }
    }
}
